
* FDNPKG16 history file *

FDNPKG16 v0.99.8254d [30 Jun 2026]
 - [mnt] cleaned a bunch of code
 - [new] added basic error levels
 - [fix] fixed a potential bug with an error catcher and lsxflag
 - [fix] fixed the untested open watcom 1.9 compiling with the makefile in DOS

FDNPKG16 v0.99.8254c [09 Jun 2026]
 - [fix] case-less file name comparisons when checking packages for conflicting files on hard disk
 - [new] you can now press a or 3 to abort the installation of a package with files on disk
 - [fix] updated translations

FDNPKG16 v0.99.8254b [28 May 2026]
 - [fix] fixed a bug with downloading a file not existing in repository. It removes the broken file downloaded.
 - [new] added a feature when downloading a package it will ask if the user wants to override the existing file on disk with same name.
 - [new] the documented features not in help are in the help now

FDNPKG16 v0.99.8254a [23 May 2026]
 - [fix] the download actions will retry to rename the downloaded file to the %temp% directory if it fails renaming the 1st time in the current working directory!

FDNPKG16 v0.99.8254 [22 May 2026]
 - [new] download feature added! you can download files into the current working directory /dl <package>
 - [new] you can now press y or n for the force package install choice
 - [fix] fixed the no packet driver spam it will quit if there is no packet driver (by size guess of htgetres == 3)
 - [fix] reimplemented no database creation if there is a problem with downloading indexes
 - [fix] bumped up memory checker size of free ram for stability with networking. sorry!
 - [new] you can download updates and not install them now with /du command

FDNPKG16 v0.99.8253d [17 Mar 2026]
 - [new] Kitten library updated!
 - [new] fdinst16.exe now has / support so now u can use /install or /in to install a package

FDNPKG16 v0.99.8253c [24 Feb 2026]
 - [fix] Updated translations
 - [mnt] Polished somethings with the code. Functionally should be the same as previous minor version.

FDNPKG16 v0.99.8253b [12 Feb 2026]
 - [fix] httpget.exe will only delete the file if the download failed and it was called from FDNPKG16.EXE with a 4th argument (the download string)

FDNPKG16 v0.99.8253a [08 Feb 2026]
 - [fix] fixed a bug in dumpcfg with install sources flag being inverted.
 - [new] httpget.exe unlinks files that fail to download.
 - [mnt] fixed alot of copyrights headers and variable names.
 - [new] fdinst16.exe has multipackage install and remove features! which means you can install more than 1 package with it at the same time now!

FDNPKG16 v0.99.8253 [04 Feb 2026]
 - [new] FDNPKG16 has NOT INSTALLED features! The document fdnpkg16.txt should explain how it works! New actions are "vnotinstalled", "notinstalled", "vn", and "ni"

FDNPKG16 v0.99.8252e [02 Feb 2026]
 - [new] FDINST16.EXE has short commands now! "in" and "rm"!
 - [mnt] Updated Documents now reflect the program fdnpkg16 and fdinst16 better now! :D
 - [nfo] Cleaned up comment and code formatting and intention everywhere a bit
 - [fix] Also HTTPGET.EXE got updated!! Some bug fixes where made and downloadstring works now for it so the string downloading the file will return international formatted strings from FDNPKG16.EXE

FDNPKG16 v0.99.8252d [31 Jan 2026]
 - [fix] Restored temp batch script creation and usage. The problem was ibiblio url is so long that system() cannot understand the very long command and throws a -1.
 - [fix] Also HTTPGET.EXE got updated!! It now returns the res variable amount on sucess and error!

FDNPKG16 v0.99.8252c [29 Jan 2026]
 - [new] katheryn's name added as a collaborator!
 - [fix] fixed 2 bugs with a QUIT(0) and a break;
 - [new] merged 2 flag variables into 1

FDNPKG16 v0.99.8252b [25 Jan 2026]
 - [nfo] optimized the code a bit more
 - [new] makefile for compiling in DOS avalible! <3

FDNPKG16 v0.99.8252a [22 Jan 2026]
 - [nfo] optimized code a bit

FDNPKG16 v0.99.8252 [13 Jan 2026]
 - [fix] Fixed a major bug with multi packages. you can now install more than 1 package of different types

FDNPKG16 v0.99.8250b [10 Jan 2026]
 - [fix] Disabled temp BAT script creation!

FDNPKG16 v0.99.8250a [06 Jan 2026]
 - [fix] found another spot where press q to quit was not fixed. it was fixed
 - [nfo] The code got slightly optimized with ifelse at the bottom of fdnpkg16.c with a variable named norepoaction

FDNPKG16 v0.99.8250 [02 Jan 2026]
 - [new] hold and unhold features! lists hold packages too! <3
 - [fix] fixed the press q to quit for uppercased Q and lower case q dose same thing now! :D

FDNPKG16 v0.99.8249c [18 Dec 2025]
 - [new] dumpcfg/dc pauses now at 25 lines now. sorry 50 lines!

FDNPKG16 v0.99.8249b [04 Nov 2025]
 - [fix] many fixes and such over the month!
 - [fix] merged fdnpkg16 and fdnpkg86 to 1 program and httpget.exe is called externally due to a memory leak bug with watt32
 - [new] added back fdinst as fdinst16.exe to prevent conflicts with existing fdinst.exe
 - [fix] many MANY bug fixes since last version here with multi package install
 - [nfo] a bunch of testing from me has been done over the past 2 weeks for finding anymore bugs
 - [nfo] FDNPKG16 is nice to use now. Very close to stable.

FDNPKG16 v0.99.8248c [13 Oct 2025]
 - [nfo] many changes since the last 2 weeks
 - [new] You can now manipulate multiple packages! (install reinstall remove update)
 - [new] Added QoL short commands
 - [new] added reinstall feature!
 - [new] added ability to reinstall local packages
 - [new] The cfg file now needs to be in same dir as program instead of being in a hard coded place like %DOSDIR%\bin\
 - [new] added force install feature!
 - [new] international support added back!
 - [fix] updated translations and got them going!
 - [new] polished and reimplemented the memory detection function for reliability reasons
 - [new] added back lzma support!
 - [new] force package installation prompt added!
 - [fix] TONS of bug fixes that where introduced.

FDNPKG16 v0.99.8 [01 Oct 2025]
 - [nfo] sparky4 (victoria crenshaw) picked up the project for FreeDOS
 - [new] renamed project to FDNPKG16 for 16 bit emphasis.
 - [new] 16 bit support! <3 with open watcom 2.0 and it compiles with 1.9.
 - [fix] the software retries downloading the files it cannot get 1st.
 - [mnt] many tweaks and such throughout the code.
 - [fix] program works on 8088 only systems now!
 - [mnt] switched development repositories to github and gitlab

FDNPKG v0.99.7 [04 Jan 2021]
 - [new] added MAPDRIVES so OS installers can install stuff to virtual drives,
 - [new] comlink launcher returns child's exit code (contributed by TK Chia),
 - [new] comlink launcher feeds two FCBs to callee (contributed by TK Chia),
 - [new] comlink frees more memory to its child (contributed by TK Chia),
 - [new] fdnpkg can display admin messages from online repositories,
 - [new] added the 'clearcache' command-line option to fdnpkg,
 - [mnt] switched repositories from svarog386.viste.fr to sourceforge.net.

FDNPKG v0.99.6 [26 Apr 2017]
 - [new] links are computed as COM files now (instead of BAT),
 - [new] support for zib (bin-only) archives to save on bandwidth,
 - [new] added German translations, contributed by Joerg Jenderek,
 - [fix] percent indicator during download doesn't go beyond 100 any more,
 - [mnt] improved performances of the full system upgrade (update) action,
 - [mnt] relicensed from GPLv3 to MIT.

FDNPKG v0.99.5 [15 May 2016]
 - [new] added Danish translations, contributed by Henrik Schick-Hansen,
 - [mnt] switched repositories from ibiblio to svarog386.viste.fr.

FDNPKG v0.99.4 [20 Dec 2015]
 - [new] FDINST returns non-zero error code if package fails to be installed,
 - [new] checking files inside packages: non-8+3 packages are rejected,
 - [new] improved memory usage in zip-loading routines,
 - [fix] replaced the tinfl lib by zlib to avoid corruptions on 16bit target,
 - [fix] FDINST does not freeze on stored files larger than 32K in size,
 - [fix] files that fail extraction are removed (were being left corrupted).

FDNPKG v0.99.3 [23 Nov 2015]
 - [fix] files zipped uncompressed are extracted correctly (v0.99.2 regress),
 - [fix] closing file descriptors on install failure (no risk of fs trashing).

FDNPKG v0.99.2 [26 Oct 2015]
 - [new] added the FDINST tool: a very light package installer for 8086+,
 - [mnt] adapted parts of the FDNPKG code for compatibility with FDINST,
 - [mnt] FDNPKG is compiled with DJGPP v2.05 (removed all hacks from 2.04).

FDNPKG v0.99.1 [15 Sep 2015] - thanks to Matej Horvath for the bug reports
 - [fix] avoiding false 'directory already exists' alerts during pkg upgrade,
 - [fix] FDNPKG UPDATE shows a progress status so users know it's not freezed.

FDNPKG v0.99 [31 Aug 2015]
 - [new] support for "link" files to include third-party apps into %PATH%,
 - [fix] compiled FDNPKG with -lemu for 387 emu, so it runs on a 386 w/o FPU,
 - [fix] during download, progress is shown on a single line (with refresh),
 - [fix] version string parser recognizes v1.0.2 as being newer than v1.01,
 - [fix] support for ZIP files that do not contain directory entries (zip -D),
 - [fix] FDNPKG is not UPXed with LZMA anymore - loads 10x faster on my 386SX,
 - [cfg] added repositories 'SOUND' and 'EDIT' to the default cfg file,
 - [cfg] sources install switched OFF by default.

FDNPKG v0.98 [15 Dec 2013]
 - [new] removed the log message 'mkdir...' when installing packages,
 - [new] using gzip index files: faster repo synch and better error detection,
 - [new] added polish translations,
 - [fix] fixed the download progress indicator for files bigger than 21M (thanks to Nilquader for the bug report),
 - [fix] improved speed of db loading from cache (avoid sorting db entries twice),
 - [fix] fixed crashes on pre-pentium CPUs caused by Watt32 using pentium opcodes (thx to sparky4 for the bug report, and Juan Guerrero for the DJGPP-related Watt32 fix),
 - [fix] when a file is being downloaded, the 'Downloading...' string is properly localized now (if localization is available),
 - [fix] updated Slovenian translations (thanks to Matej Horvat for the translation work).

FDNPKG v0.97 [10 Oct 2013]
 - [new] added a new action 'listfiles' to list files owned by a package,
 - [new] added proxy support for HTTP repositories,
 - [new] added slovenian translations (thanks to Matej Horvat).

FDNPKG v0.96 [21 Jul 2013]
 - [fix] replaced the inflate routine from kunzip by the tinfl library, because the former was crashing on some files compressed with 7za,
 - [fix] package removal removes all directories of a package, even when there are more than 256 of them,
 - [fix] lst files are written with correct line terminators (was ending lines with \r\r\n instead of \r\n),
 - [fix] fixed a crash occuring because of memory corruption after a faulty free(),
 - [new] when downloading a package, the package filename is displayed ("Downloading tree.zip..."),
 - [new] added support for parsing (and understanding) versions with a single letter suffix (eg. 1.0a, 3.4c, etc),
 - [new] optimized memory management - storing packages metadata consumes 2x to 3x less memory now (with current FreeDOS repositories, FDNPKG memory consumption dropped from 192 KB to 64 KB),
 - [new] added a test checking the writeability of %TEMP% before proceeding to any actions,
 - [new] additional check for ZIP archives pre-validation: reject files that lack a central directory entry (because it's probably a truncated archive),
 - [new] encrypted archives are properly recognized, and a meaningful error message is provided to the user,
 - [new] lowered the stack memory required by fdnpkg from 1M to 512K (this was possible due to recent reimplementation of zip and http modules),
 - [new] added a warning at FDNPKG start when the available virtual memory seems dangerously low (less than 3 MiB),
 - [new] added a simplistic http answer parser to recognize non-200 answers sent by http servers, thus aborting the download,
 - [new] added support for http 'content-length', so FDNPKG show some % progress during download,
 - [new] embedded the cwsdpmi stub into the fdnpkg.exe binary to make it fully standalone,
 - [new] after a package is installed, fdnpkg prints the count of files extracted vs the count of extraction errors.

FDNPKG v0.95 [11 Jul 2013]
 - [fix] when updating a package, the new candidate is downloaded and checked before the current package is removed from the system (before we could end with our package being removed and none installed if the download failed on the new one),
 - [fix] remote package is not downloaded anymore if it's already installed (unless we want to update it),
 - [new] replaced the embedded UNZIP kludge by my own unzip implementation,
 - [new] replaced the embedded htget kludge by my own, lighter & simpler http implementation,
 - [new] the directory %DOSDIR%\packages is created automatically when installing the first package,
 - [new] the 'install' action do not ask what package version to install, and installs the most recent one if it's possible to figure out the latest version automatically (otherwise asks the user as before),
 - [new] added gopher support for online repositories storage,
 - [new] added support for LZMA-compressed packages,
 - [new] added a progress feedback when downloading files, so in case of big packages taking a long time to download, the user don't think anymore that fdnpkg freezed,
 - [new] added the possibility to update all packages in the system to latest version at once (if newer versions are available), via 'fdnpkg update',
 - [new] renamed the 'showinstalled' action to 'listlocal', as the latter is shorter/faster to type (but 'showinstalled' still works for backward compatibility),
 - [new] refactored the whole networking code to make it much easier to integrate other tcp/ip stacks in the futur (mTCP maybe, if it makes it into the 32bit world?).

FDNPKG v0.94 [19 Jun 2013]
 - [fix] FDNPKG is quitting if networking (Watt32) fails to initialize (was trying to continue anyway, possibly leading to crashes),
 - [new] added support for on-disk package repositories,
 - [new] added the 'showinstalled' action (display the list of installed packages),
 - [new] added the 'checkupdates' action (checks for availability of updates for installed packages),
 - [new] added the 'update' action (updates given package to newer version from repositories),
 - [new] added support for custom configuration file location via the FDNPKG.CFG environnement variable.

FDNPKG v0.93a [20 Feb 2013]
 - [fix] fixed a minor bug related to paths parsing, which made installing packages from local zip files failing in some situations (thanks to sparky4 for reporting this).

FDNPKG v0.93 [17 Feb 2013]
 - [fix] the CRC32 algorithm used for internal FDNPKG needs has been fixed to compute the same CRC32 sums as used by ethernet,
 - [new] added CRC32 checksum verification on downloaded packages before installation,
 - [new] added the CRC32 of packages in the vsearch output,
 - [new] made the default 'install/don't install sources' choice configurable via the cfg file,
 - [new] added the 'install-wsrc' action to force sources installation,
 - [new] implemented configurable custom directories for different packages types (games, devel...),
 - [new] truncating packages descriptions in 'search' and 'vsearch' outputs at screen's last column instead of using a fixed lenght of 63 bytes (provides a little bit more of descriptions and makes the list visually nicer),
 - [new] storing absolute paths to installed files and directories in packages\*.lst listing files,
 - [new] replaced the 'listrep' action by 'dumpcfg'.

FDNPKG v0.92 [31 Jan 2013]
 - [fix] fixed a bug in handling the tmp index in hardcoded c:\temp instead of relying on %TEMP% (thanks to Rugxulo and Bernd Blaauw for reporting this!),
 - [fix] configured new official FreeDOS v1.1 repositories in the default configuration file,
 - [new] FDNPKG checks for the presence of an APPINFO file prior to installing the package (thanks to sparky4 for the suggestion),
 - [new] added the install-nosrc action allowing to install packages without their sources,
 - [new] implemented a local package database cache to speed up searching through packages,
 - [new] silently skipping the packages/pkgname.lst file, if present in the packages (because FDNPKG computes its own one).

FDNPKG v0.91 [11 Nov 2012]
 - [fix] fixed a memory leak when aborting package installation due to pkgname.lst file access error,
 - [new] added support for the FreeDOS NLS system via the Kitten library (and bundled the fdnpkg.en template)
 - [new] verifying that there is no collision between files in the package to be installed and any already existing local file before actual package installation.

FDNPKG v0.9 [24 Sep 2012]
 - [new] first public release.
